package NucPred;

############################################
# Distributed under the GNU Public License #
# see the accompanying file LICENSE.txt    #
############################################

# this is for the 'eval' timeout
use POSIX ':signal_h';
sigaction SIGALRM, new POSIX::SigAction sub { die "alarmed (SigAction handler)" };


sub new {
  my ($class, @args) = @_;
  my $self = { };
  bless $self, $class;
  $self->_init(@args);
  return $self;
}

sub _init {
  my ($self, @files) = @_;

  $self->{predictors} = [];
  foreach my $file (@files) {
    if (open(PERL, $file)) {
      my $perl = '';
      while (<PERL>) {
	if ($perl || /^sub nuclear_score/) {
	  $perl .= $_;
	}
      }
      close(PERL);
      $perl =~ s/sub \w+\s+/sub /; # make subroutines anonymous
      push @{$self->{predictors}}, eval "$perl;";
    }
  }
}

sub score_sequence {
  my ($self, $seq, $thresh) = @_;
  $thresh = 0 unless (defined $thresh);

  my $votes = 0;
  foreach $sub (@{$self->{predictors}}) {
    alarm 2; # this is needed in case there is a regular expression
             # which does excessive backtracking (on KKKKKKKKKKK for example)
    my $score = eval {
		       $sub->($seq)
		     }; # could be divide by zero etc
    alarm 0; # cancel the alarm
    $votes++ if (defined $score && $score > $thresh);
  }
  my $n = @{$self->{predictors}};
  return $votes/$n;
}



1;
